(*  Title:      BridgeJEdit/E_Collect.thy
    Author:     Walther Neuper, JKU Linz

This is a stub for a collection of learning material in the line of
http://www.ist.tugraz.at/projects/isac/www/kbase/exp/index_exp.html,
for instance Examples > Statics > Biegelinien, or
             Examples > IsacCore > Calculus > Differentiation.
*)
theory E_Collect
  imports "$ISABELLE_ISAC/Knowledge/Build_Thydata"
begin

ML \<open>
signature EBOOK_COLLECTION =
sig
  val demo_example: Example.T
end

(**)
structure E_Collect(**) : EBOOK_COLLECTION(**) =
struct
(**)

(** an example for demonstration **)
(*
  For notes from ISAC's discontinued Java front-end see
  \<^url>\<open>https://isac.miraheze.org/wiki/Extend_ISAC_Knowledge#Add_an_example_in_XML_format\<close>
*)
val demo_example = ("The efficiency of an electrical coil depends on the mass of the kernel." ^
  "Given is a kernel with cross-sectional area determined by two rectangles" ^
  "of same shape as shown in the figure." ^
  "Given a radius r = 7, determine the length u and width v of the rectangles" ^
  "such that the cross-sectional area A (and thus the mass of the kernel) is a" ^
  "maximum. + Figure", 
   ([
   (*Problem model:*)
     "Constants [r = (7::real)]", "Maximum A", "AdditionalValues [u, v]",
     "Extremum (A = 2 * u * v - u \<up> 2)",
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]",
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]",
     "SideConditions [(u::real) / 2 = r * sin \<alpha>, 2 / v = r * cos \<alpha>]",
   (*MethodC model:*)
     "FunctionVariable a", "FunctionVariable b", "FunctionVariable \<alpha>",
     "Domain {0 <..< r}",
     "Domain {0 <..< r}",
     "Domain {0 <..< \<pi> / 2}",
     "ErrorBound (\<epsilon> = (0::real))"]: TermC.as_string list,
    ("Diff_App", ["univariate_calculus", "Optimisation"], 
      ["Optimisation", "by_univariate_calculus"]): References.T)): Example.T

(**)end(*struct*)
\<close>
setup \<open>Know_Store.add_expls [(E_Collect.demo_example, ["Diff_App-No.123a"])]\<close>

ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

end